## galaxy-开发/测试环境 docker-compose

## Get Start
```
# 安装dev环境到本地
curl -o install.sh http://192.168.11.163/demo/install.sh && bash install.sh dev

```

## services
1. php7
2. php8
3. nginx
4. java-notice
5. java-biz-platform
6. java-flowengine
7. java-intelligentwriting
8. java-client
9. nacos-client 非项目使用

### 服务目录汇总

| 服务名                   | 描述                          | 仓库地址                                                                          | 目录名称                          | 状态    | 技术栈 | 端口                                  | 备注                 |
|:------------------------|:-----------------------------|:---------------------------------------------------------------------------------|:--------------------------------|:-------|:------|:-------------------------------------|:--------------------|
| BaseMicros              | 无                           | -                                                                                | -                               | 疑似弃用 | -     | -                                    |                     |
| MarketMicros            | 无                           | -                                                                                | -                               | 疑似弃用 | -     | -                                    |                     |
| FlowMicros              | Crm重构-流程管理相关的微服务      | http://gitlab.galaxy-immi.com/colnet/bp/FlowMicros.git                           | flow-micros                     | 正常    | php   | $GALAXY_FLOW_MICROS_API_HTTP_PORT    |                     |
| UserMicros              | Crm重构-用户管理相关的微服务      | http://gitlab.galaxy-immi.com/colnet/bp/UserMicros.git                           | user-micros                     | 正常    | php   | $GALAXY_USER_MICROS_API_HTTP_PORT    |                     |
| FlowEngineMicros        | 工作流引擎                     | http://gitlab.galaxy-immi.com/colnet/engine.git                                  | flowengine                      | 正常    | java  | 80 (单独容器服务,内部端口)               |                     |
| ServerSiteMicros        | 服务端相关的微服务              | http://gitlab.galaxy-immi.com/colnet/mp/ServerSiteMirocs.git                     | server-site                     | 正常     | php  | $GALAXY_SERVER_SITE_API_HTTP_PORT    |                     |
| NoticeMicros            | 通用通知服务                   | http://gitlab.galaxy-immi.com/colnet/notice.git                                  | notice                          | 正常    | java  | 80                                   |                     |
| PromotionMicros         | 无                           | -                                                                                | -                               | 疑似弃用 | -     | -                                    |                     |
| MemberMicros            | MemberMicros                 | http://gitlab.galaxy-immi.com/colnet/bp/MemberMicros.git                         | member-micros                   | 正常    | php   | $GALAXY_MEMBER_API_HTTP_PORT         |                     |
| PresaleMicros           | PresaleMicros                | http://gitlab.galaxy-immi.com/colnet/fp/PresaleMicros.git                        | presale-micros                  | 正常    | php   | $GALAXY_PRESALE_MICROS_API_HTTP_PORT |                     |
| BizPlatform             | BizPlatform                  | http://gitlab.galaxy-immi.com/colnet/biz-platform.git                            | biz-platform                    | 正常    | java  | 80                                   |                     |
| CrmClient               | 客户端微服务                   | http://gitlab.galaxy-immi.com/colnet/bp/ClientMicros.git                         | client                          | 正常    | java  | java:80                              | hostfile配置前端地址   |
| CrmClient               | crm文案部客户端前端             | http://gitlab.galaxy-immi.com/Front-end-group/CrmClientHtml.git                  | crm-client                      | 正常    | vue   | vue:$OLD_CRM_CLIENT_HTTP_PORT        | hostfile配置前端地址  |
| common-server           | 银河公共服务                   | http://gitlab.galaxy-immi.com/colnet/common-server.git                           | common-server                   | 正常    | php   | $GALAXY_COMMON_SERVER_API_HTTP_PORT  |                     |
| workflow-server         | 工作流引擎                     | http://gitlab.galaxy-immi.com/colnet/bp/galaxy-workflow.git                      | galaxy-workflow                 | 正常    | php   | $GALAXY_WORKFLOW_API_HTTP_PORT       |                     |
| data-center             | -                            | -                                                                                | -                               | 正常    | -     | -                                    | 待后续补充            |
| node                    | -                            | -                                                                                | -                               | 正常    | -     | -                                    | 待后续补充            |
| CRM                     | 新CRM系统服务端                | http://gitlab.galaxy-immi.com/colnet/fp/CRM.git                                  | crm                             | 正常    | vue   | $OLD_CRM_HTTP_PORT                   |                     |
| CRM-ADMIN               | 新CRM系统管理端                | http://gitlab.galaxy-immi.com/colnet/fp/CRM-Admin.git                            | crm-admin                       | 正常    | vue   | $OLD_CRM_ADMIN_HTTP_PORT             |                     |
| DWP/MAIN                | 文案系统                      | http://gitlab.galaxy-immi.com/Front-end-group/Service-Front/Document-System.git  | dwp/main                        | 正常     | vue  | $DWP_HTTP_PORT                       |                     |
| DWP/SUBAPP/Chatbot      | Chatbot智能机器人配置端         | http://gitlab.galaxy-immi.com/Front-end-group/Manage-Frame/Chatbot.git           | dwp/subapp/chatbot_admin        | 正常    | vue   | $DWP_HTTP_PORT                       |                     |
| DWP/SUBAPP/earlyWarning | 智能预警/代办                  | http://gitlab.galaxy-immi.com/Front-end-group/Manage-Frame/Early-Warning.git     | dwp/sub/app/earlyWarning        | 正常    | vue   | $DWP_HTTP_PORT                       |                     |
| DWP/SUBAPP/userInfo     | dwp项目管理-客户详情            | http://gitlab.galaxy-immi.com/Front-end-group/Service-Front/User-Information.git | dwp/sub/app/userInfo            | 正常    | vue   | $DWP_HTTP_PORT                       |                     |
| Entry                   | 香港入境处身份证预约抢号          | http://gitlab.galaxy-immi.com/colnet/mp/Entry.git                                | entry                           | 正常    | vue   | $GALAXY_ENTRY_API_HTTP_PORT          |                     |
| galaxy-crm              | -                            | http://gitlab.galaxy-immi.com/micro/galaxy-crm.git                               | galaxy-crm                      | 正常    | php   | $GALAXY_CRM_API_HTTP_PORT            |                     |
| intelligentwriting      | 智能写作后台                   | http://gitlab.galaxy-immi.com/colnet/smart-writing/Intelligentwriting.git        | intelligentwriting              | 正常    | java  | $OLD_CRM_ADMIN_HTTP_PORT             | old crm代理到java服务 |
| MicroserviceGateway     | micros-gateway               | http://gitlab.galaxy-immi.com/colnet/gateway/MicroserviceGateway.git             | micros-gateway                  | 正常    | php   | $GALAXY_MICROS_GATEWAY_API_HTTP_PORT | 代理转发             |
| user-information-system | 用户基础信息平台（981/997)      | http://gitlab.galaxy-immi.com/colnet/fp/User-Information-System.git              | user-information-system         | 正常     | vue  | $OLD_CRM_USER_HTTP_PORT              |                     |
| Notice-Center           | Notice-Center                | http://gitlab.galaxy-immi.com/colnet/noticeCenter.git                            | notice-center                   | 正常    | php   | $NOTICE_CENTER_HTTP_PORT             |                     |
| Notice-FRONT            | Notice-Center前端-智能预警/代办 | http://gitlab.galaxy-immi.com/Front-end-group/Manage-Frame/Early-Warning.git     | smartwhale/subapp/early_warning | 正常    | vue   | $VUE_NOTICE_CENTER_HTTP_PORT         |                     |
| domain-module           | 领域服务                      | http://gitlab.galaxy-immi.com/colnet/domain-module.git                           | domain-module                   | 正常     | php  | $DOMAIN_MODULE_HTTP_PORT             | php8                |

## 环境依赖
- docker  必须
- git     必须
- supervisor 如不需要跑任务可不用

## 安装与部署
1. 本地或远程机器 git clone 仓库代码
```shell script
git clone git@gitlab.galaxy-immi.com:kunkka.wh/docker-test.git
cd galaxy
cp .env.example .env 
# 修改.env
# ENV = 环境
# PORT = 服务端口
# CODE_DIR = 挂载目录
# 部署代码
# 启动容器环境 docker-compose/docker compose
docker compose up -d # 或 docker-compose up -d
# 销毁环境环境
docker compose down --rmi all # 销毁并删除镜像
```


## 代码更新
- php以及前端 CODE_DIR 目录到指定的前后端更新代码，git pull或其他处理方式，无需重启容器
- java代码更新,CODE_DIR java代码更新之后，重启容器时会自动打包

## 执行脚本
```shell script
# 手动执行 仓库有要给.bashrc 
source .bashrc 
php7 dev/galaxy-crm/artisan  route:list # 不同环境执行不同的路径
# 任务执行
docker run --rm -it  --network  galaxy-net -v $(pwd):/app harbor.galaxy-immi.com/galaxy-open-develop/php:7.4  php dev/galaxy-crm/artisan route:list

```
## 执行计划任务
如上所示，在宿主机统一配置所有环境的 artisan schedule:run 或artisan schedule:work
## 常驻进程管理
宿主机维护supervisor 去统一管理所有环境所有项目路径的任务
以galaxy-crm-dev举例 新增galaxy-crm-dev-schedule.conf 计划任务配置
**下面配置会启动通过镜像启动一个容器并执行命令，当命令执行结束后容器会自动销毁**
```shell script
[program:galaxy-crm-dev-schedule]
process_name=%(program_name)s
command=/usr/bin/docker run --rm   --network  galaxy-net -v /home/www/code/galaxy-crm:/app harbor.galaxy-immi.com/galaxy-open-develop/php:7.4 php artisan schedule:work
autorestart=true
user=root
numprocs=1
redirect_stderr=true
stdout_logfile=/opt/supervisord/log/galaxy-crm-dev.log
stderr_logfile=/opt/supervisord/log/galaxy-crm-dev-err.log

```

## 配置统一
nacos配置中心地址：http://192.168.11.163:8848/nacos  
账号:nacos 密码:nacos

创建配置规则: CODE_DIR的目录名称+ ENV ,举例，galaxy-crm的dev环境配置data-id是galaxy-crm-dev
目前是有nacos-client轮询更新,间隔30s检查一次

## 多环境问题
由于dev和test都只有一套db环境，新增的环境时，修改ENV，并根据env到配置中心创建配置即可部署多环境
- 每一套环境对应一套配置

## 备注
- 如本地虚拟机启动容器，建议cpu内存配置分配至少 4c8g
- dev 所有项目的代码目录下载地址: [code-demo-920.tgz](http://192.168.11.163/demo/code-demo-920.tgz)
```
├── biz-platform
├── client
├── common-server
├── crm
├── crm-admin
├── crm-client
├── dwp
├── entry
├── flowengine
├── flow-micros
├── galaxy-crm
├── galaxy-workflow
├── intelligentwriting
├── member-micros
├── micros-gateway
├── notice
├── notice-center
├── presale-micros
├── server-site
├── smartwhale
├── user-information-system
└── user-micros
```
- 解压时候，放到CODE_DIR目录下面，然后启动docker compose

